/*
 * $Header: /home/cvspublic/jakarta-commons-sandbox/resources/src/java/org/apache/commons/resources/ResourcesFactoryFinder.java,v 1.7 2004/03/27 21:34:10 dgraham Exp $
 * $Revision: 1.7 $
 * $Date: 2004/03/27 21:34:10 $
 *
 * ====================================================================
 *
 *  Copyright 2003-2004 The Apache Software Foundation
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * 
 */

package org.apache.commons.resources;

import org.apache.commons.discovery.tools.DiscoverClass;

/**
 * <p>Convenience factory class for instantiating an implementation of
 * {@link org.apache.commons.resources.ResourcesFactory} based on the discovery 
 * features of the <code>commons-discovery</code> package.</p>
 */
public class ResourcesFactoryFinder {

    /**
     * <p>Create and return a {@link org.apache.commons.resources.ResourcesFactory} instance based on
     * dynamic discovery of the desired implementation class.  No
     * default implementation is specified.</p>
     *
     * @exception Exception if thrown during service discovery
     */
    public static ResourcesFactory getResourcesFactory() throws Exception {

        Class spiInterface = ResourcesFactory.class;
        Class spiClass =
            new DiscoverClass().find(spiInterface);
        ResourcesFactory spiImpl = (ResourcesFactory) spiClass.newInstance();
        return (spiImpl);

    }


}
